/* global require, module */

var EmberApp = require('ember-cli/lib/broccoli/ember-app');
var pickFiles = require('broccoli-static-compiler');
var mergeTrees = require('broccoli-merge-trees');

var app = new EmberApp();

// Use `app.import` to add additional libraries to the generated
// output files.
//
// If you need to use different assets in different
// environments, specify an object as the first parameter. That
// object's keys should be the environment name and the values
// should be the asset to use in that environment.
//
// If the library that you are including contains AMD or ES6
// modules that you would like to import into your application
// please specify an object with the list of modules as keys
// along with the exports of each module as its value.
app.import('vendor/bootstrap/dist/js/bootstrap.js');
app.import('vendor/bootstrap/dist/css/bootstrap.css');
app.import('vendor/highlightjs/highlight.pack.js');
app.import('vendor/highlightjs/styles/tomorrow.css');
app.import('vendor/fontawesome/css/font-awesome.css');
var extraAssets = pickFiles('vendor/fontawesome', {
    srcDir: '/',
    files: ['**/*.woff', '**/*.eot', '**/*.svg', '**/*.ttf'],
    destDir: '.'
});

//We need this somehow to be included automatically, if not we need to notify users to import
app.import('vendor/ic-styled/main.js');
app.import('vendor/ember-validations/ember-validations.js');
app.import('vendor/ember-utils/dist/globals/main.js');
//App itself (not needed if server is up)
app.import('vendor/ember-forms/dist/ember_forms.js');
app.import('vendor/ember-components/dist/globals/main.js');

module.exports = mergeTrees([app.toTree(), extraAssets])