`import Ember from "ember"`

Forms = Ember.ArrayController.extend
    message: 'Please submit or cancel the form.'
    model: [
        {title: 'tag1'}
        {title: 'tag2'}
    ]
    #true if the form is currently being submitted
    submitting: false

    #The new tag to be added
    newTag: undefined

    initNewTag: (->
        @set 'newTag', {}
    ).on('init')

    actions:
        #Save the tag on the server
        addTag: (m, e) ->
            e.promise = @fakePromise(@get('tag')).then((t) =>
                @model.addObject @get('newTag')
                @initNewTag()
            )

        cancelled: ->
            @set 'message', '<b>Form did not submit.</b>'

    fakePromise: (objToReturn) ->
        new Promise((res, rej) =>
            Ember.run.later(=>
                @set 'message', '<b>Form submitted!</b>'
                res(objToReturn)
            , 1500)
        )
`export default Forms`
